# Define the array of values for the 'model' argument
#models=("mistral" "mixtral")
#models=("claude-3-opus" 'mistral' 'mixtral')

# Define the array of values for the 'output_model' argument
#output_models=("mistral" "mixtral" "claude-3-opus")
#models=("llama-70B-chat" "mistral" "mixtral")
#models=("llama-7B-chat" "llama-13B-chat" "llama-70B-chat" "mistral" "mixtral")
models=("claude-3-sonnet" "claude-3-opus" "claude-3-haiku")
omodels=("claude-3-sonnet" "claude-3-opus" "claude-3-haiku")
#omodels=("claude-3-sonnet")
#models=("llama-7B-chat")
#omodels=("claude-3-haiku")
export N_EXAMPLES=300
export N_SECURE_EXAMPLES=100

echo "Iterate through each model and first create the vulnerable code and the secure code. Also will do the evaluation for the vulnerable code"
for model in "${models[@]}"; do
  # Iterate through each output model
  export CMD_STR="run_experiment.py --n_examples $N_EXAMPLES --model $model --experiment_name write-vulnerable-code"
  #echo $CMD_STR
  #python $CMD_STR
  export CMD_STR="run_experiment.py --n_examples $N_SECURE_EXAMPLES --model $model --experiment_name write-secure-code"
  #echo $CMD_STR
  #python $CMD_STR
  export CMD_STR="run_experiment.py --experiment_name evaluate-vulnerable-code --model gpt-4-turbo --output_model $model --n_examples $N_EXAMPLES"
  #echo $CMD_STR
  #python $CMD_STR
done

echo "Repeat this process for the output models"
for model in "${omodels[@]}"; do
  # Iterate through each output model
  export CMD_STR="run_experiment.py --n_examples $N_EXAMPLES --model $model --experiment_name write-vulnerable-code"
  #echo $CMD_STR
  #python $CMD_STR
  export CMD_STR="run_experiment.py --n_examples $N_SECURE_EXAMPLES --model $model --experiment_name write-secure-code"
  #echo $CMD_STR
  #python $CMD_STR
  export CMD_STR="run_experiment.py --experiment_name evaluate-vulnerable-code --model gpt-4-turbo --output_model $model --n_examples $N_EXAMPLES"
  #echo $CMD_STR
  #python $CMD_STR
done

echo "Now, creating secure code with refrence and running the evaluation"
for model in "${models[@]}"; do 
  for omodel in "${omodels[@]}"; do
    # Execute the command with the current model and output_model
    export CMD_STR="run_experiment.py --experiment_name write-vulnerable-code-from-secure --model $model --output_model $omodel --n_examples $N_EXAMPLES"
    echo $CMD_STR
    python $CMD_STR
    export CMD_STR="run_experiment.py --experiment_name evaluate-vulnerable-code --model gpt-4-turbo --output_model $model --reference_model $omodel --n_examples $N_EXAMPLES"
    echo $CMD_STR
    python $CMD_STR
  done
done

# First, create the code with referneces
echo "Now, creating secure code with just the model and running the evaluation"
for model in "${models[@]}"; do
    # Run this for each individual model
    export CMD_STR="run_experiment.py --experiment_name write-vulnerable-code-from-secure --model $model --output_model $model --n_examples $N_EXAMPLES"
    #echo $CMD_STR
    #python $CMD_STR
    export CMD_STR="run_experiment.py --experiment_name evaluate-vulnerable-code --model gpt-4-turbo --output_model $model --reference_model $model --n_examples $N_EXAMPLES"
    #echo $CMD_STR
    #python $CMD_STR
done